/*
 * LCD framebuffer server functionality.
 *
 * Copyright (C) 2018, 2023 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#ifdef __cplusplus

#include <l4/devices/fb-server.h>
#include <l4/devices/lcd-device.h>
#include <l4/re/c/dataspace.h>

class Framebuffer_lcd_server : public Framebuffer_server
{
  Lcd_device *_device;

protected:
  /* Specialised methods. */

  l4_size_t _get_framebuffer_size();
  void _get_view_info(l4re_video_view_info_t *view_info);

public:
  explicit Framebuffer_lcd_server(l4re_ds_t mem, Lcd_device *device)
  : Framebuffer_server(mem), _device(device)
  {
  }
};

#endif
